
(function() {
    "use strict";

    // ギャル文字変換用関数
    function convertToGalmoji(str) {
        console.log(str)
        if (!str || typeof str !== 'string') {
            return str;
        }

        // ギャル文字への変換マップ
        var galmojiMap = {
            'あ': 'ぁ', 'い': 'ﾚヽ', 'う': 'ぅ', 'え': 'ぇ', 'お': 'ぉ',
            'か': 'ｶゝ', 'き': 'ｷ', 'く': '＜', 'け': 'ﾚﾅ', 'こ': '⊇',
            'さ': '､ﾅ', 'し': 'ι', 'す': 'す', 'せ': 'せ', 'そ': 'ξ',
            'た': 'ﾅﾆ', 'ち': 'ち', 'つ': '⊃', 'て': 'τ', 'と': 'ー⊂',
            'な': 'ﾅょ', 'に': 'ﾚﾆ', 'ぬ': 'ぬ', 'ね': 'ね', 'の': '＠',
            'は': 'ﾚよ', 'ひ': 'ひ', 'ふ': '､ζ', 'へ': '､∧', 'ほ': 'ﾚま',
            'ま': 'ま', 'み': 'ゐ', 'む': '￡ヽ', 'め': 'め', 'も': 'も',
            'や': 'ゃ', 'ゆ': 'ゅ', 'よ': 'ょ',
            'ら': 'ʖ', 'り': 'ˋ)', 'る': 'ゑ', 'れ': 'れ', 'ろ': 'з',
            'わ': 'ゎ', 'を': 'を', 'ん': 'ω',
            'ゐ': 'ゐゝ', 'ゑ': 'ゑゝ',
            'が': 'ｶゝ゛', 'ぎ': 'ｷ゛', 'ぐ': '＜゛', 'げ': 'ﾚﾅ゛', 'ご': '⊇゛',
            'ざ': '､ﾅ゛', 'じ': 'ι゛', 'ず': 'す゛', 'ぜ': 'せ゛', 'ぞ': 'ξ゛',
            'だ': 'ﾅﾆ゛', 'ぢ': 'ち゛', 'づ': '⊃゛', 'で': 'τ゛', 'ど': 'ー⊂゛',
            'ば': 'ﾚよ゛', 'び': 'ひ゛', 'ぶ': '､ζ゛', 'べ': '∧゛', 'ぼ': 'ﾚま゛',
            'ぱ': 'ﾚよ゜', 'ぴ': 'ひ゜', 'ぷ': '､ζ゜', 'ぺ': '∧゜', 'ぽ': 'ﾚま゜',
            'ア': '了', 'イ': 'ｨ', 'ウ': 'ｩ', 'エ': '工', 'オ': '才',
            'カ': 'ヵ', 'キ': '≠', 'ク': '勹', 'ケ': 'ヶ', 'コ': '］',
            'サ': '廾ﾞ', 'シ': '/', 'ス': 'ｽ', 'セ': 'ｾ', 'ソ': '｀／',
            'タ': '勺', 'チ': '于', 'ツ': '"/', 'テ': '〒', 'ト': '├',
            'ナ': 'ﾅ', 'ニ': '二', 'ヌ': 'ﾇ', 'ネ': 'ﾈ', 'ノ': '丿',
            'ハ': 'ﾉヽ', 'ヒ': 'ｔ', 'フ': '┐', 'ヘ': '∧', 'ホ': '朮',
            'マ': 'ﾏ', 'ミ': '彡', 'ム': '厶', 'メ': '乂', 'モ': 'ﾓ',
            'ヤ': 'ﾔ', 'ユ': 'ﾕ', 'ヨ': '∋',
            'ラ': 'ﾗ', 'リ': '└|', 'ル': '｣ﾚ', 'レ': '∠', 'ロ': '□',
            'ワ': 'ﾜ', 'ヲ': 'ｦ', 'ン': '･/',
            'ガ': 'ヵ゛', 'ギ': '≠゛', 'グ': '勹゛', 'ゲ': 'ヶ゛', 'ゴ': '］゛',
            'ザ': '廾ﾞ゛', 'ジ': '/゛', 'ズ': 'ｽ゛', 'ゼ': 'ｾ゛', 'ゾ': '｀／゛',
            'ダ': '勺゛', 'ヂ': '于゛', 'ヅ': '"/゛', 'デ': '〒゛', 'ド': '├゛',
            'バ': 'ﾉヽ゛', 'ビ': 'ｔ゛', 'ブ': '┐゛', 'ベ': '∧゛', 'ボ': '朮゛',
            'パ': 'ﾉヽ゜', 'ピ': 'ｔ゜', 'プ': '┐゜', 'ペ': '∧゜', 'ポ': '朮゜'
        };

        return str.split('').map(function(char) {
            return galmojiMap[char] || char;
        }).join('');
    }

    // フィールドの値をギャル文字に変換する関数
    function convertFields(record) {
        for (var fieldCode in record) {
            var field = record[fieldCode];
            if (field && (field.type === 'SINGLE_LINE_TEXT' || field.type === 'MULTI_LINE_TEXT')) {
                field.value = convertToGalmoji(field.value);
            }
        }
        return record;
    }

    // レコード編集・作成イベントに対するハンドラー
    kintone.events.on(['app.record.create.submit', 'app.record.edit.submit'], function(event) {
        event.record = convertFields(event.record);
        return event;
    });

})();
